﻿;console.log('');if(location.href.indexOf('ile:')<0){if(location.href.indexOf('pm')<0){}};class LittleMac {
  constructor(settings = {}) {
    this.originalSettings = {
      glove: {
        size: 80 },

      is: {
        blocking: false },

      state: 'enable' // disable, tired
    };

    this.settings = { ...this.originalSettings, ...settings };
    this.settings.touch = 'ontouchstart' in document.documentElement;

    this.keys = {
      up: false };


    this.lft = {
      name: 'left',
      el: document.querySelector('.hand.left'),
      started: null,
      x: {
        min: this.settings.glove.size * -0.5,
        max: this.settings.glove.size,
        start: 0,
        current: 0 },

      y: {
        min: this.settings.glove.size * -2,
        max: this.settings.glove.size * 1.5,
        start: 0,
        current: 0 },

      get jab() {
        return this.x.current > 50 && this.y.current < 120;
      },
      get punch() {
        return this.x.current < -10 && this.y.current < 120;
      },
      get uppercut() {
        return this.x.current > 50 && this.y.current > 80;
      },
      get dodge() {
        return this.x.current < -30 && this.y.current > 80;
      },
      get block() {
        return this.x.current > 50 && this.y.current < 20 && this.y.current > -20;
      } };


    this.rgt = {
      name: 'right',
      el: document.querySelector('.hand.right'),
      started: null,
      x: {
        min: this.settings.glove.size * -1,
        max: this.settings.glove.size * 0.5,
        start: 0,
        current: 0 },

      y: {
        min: this.settings.glove.size * -2,
        max: this.settings.glove.size * 1.5,
        start: 0,
        current: 0 },

      get jab() {
        return this.x.current < -50 && this.y.current < 120;
      },
      get punch() {
        return this.x.current > 10 && this.y.current < 120;
      },
      get uppercut() {
        return this.x.current < -50 && this.y.current > 80;
      },
      get dodge() {
        return this.x.current > 30 && this.y.current > 80;
      },
      get block() {
        return this.x.current < -50 && this.y.current < 20 && this.y.current > -20;
      } };


    this.dom = {
      ring: document.querySelector('.ring'),
      mac: document.querySelector('.mac'),
      sprite: document.querySelector('.mac__sprite'),
      keyboard: document.querySelector('.keyboard') };


    this.init();
  }

  init() {
    console.log('mac');
    this.setControllerType();
  }

  state(state = 'enable') {
    if (state !== this.settings.state) {
      this.dom.mac.classList.remove(`is-${this.settings.state}`);
      this.dom.mac.classList.add(`is-${state}`);
      this.settings.state = state;
    }
  }

  setControllerType() {
    if (this.settings.touch) {
      document.body.classList.add('touch-controller');
      document.body.classList.remove('keyboard-controller');
      this.bindTouchEvents();
    } else {
      document.body.classList.add('keyboard-controller');
      document.body.classList.remove('touch-controller');
      this.bindKeyboardEvents();
    }
  }

  bindTouchEvents() {
    this.dom.ring.addEventListener('touchstart', e => e.preventDefault());
    this.dom.ring.addEventListener('touchmove', e => e.preventDefault());
    // Left hand
    this.lft.el.addEventListener('touchstart', e => this.handStart(this.lft, e), true);
    this.lft.el.addEventListener('touchmove', e => this.handMove(this.lft, e), true);
    this.lft.el.addEventListener('touchend', e => this.handEnd(this.lft), true);
    this.lft.el.addEventListener('touchcancel', e => this.handEnd(), true);
    // Right hand
    this.rgt.el.addEventListener('touchstart', e => this.handStart(this.rgt, e), true);
    this.rgt.el.addEventListener('touchmove', e => this.handMove(this.rgt, e), true);
    this.rgt.el.addEventListener('touchend', e => this.handEnd(this.rgt), true);
    this.rgt.el.addEventListener('touchcancel', e => this.handEnd(), true);
  }

  bindKeyboardEvents() {
    window.addEventListener('keydown', e => this.keyDown(e));
    window.addEventListener('keyup', e => this.keyUp(e));
  }

  keyDown(e) {
    e.preventDefault();
    e = e || window.event;
    const key = e.code.toLowerCase();
    console.log(key);

    if (!e.repeat) {
      if (key === 'arrowup') {
        this.keys.up = true;
        this.dom.keyboard.classList.add('arrowup');
      } else if (key === 'arrowdown') {
        this.isBlocking = true;
        this.dom.mac.classList.add('block');
        this.dom.keyboard.classList.add('arrowdown');
      }

      if (!this.isBlocking) {
        if (this.settings.state === 'enable' || this.settings.state === 'tired') {
          if (key === 'arrowleft') this.macAnimation('left', 'dodge');else
          if (key === 'arrowright') this.macAnimation('right', 'dodge');

          if (this.settings.state === 'enable') {
            if (this.keys.up && key === 'keyz') this.macAnimation('left', 'jab');else
            if (this.keys.up && key === 'keyx') this.macAnimation('right', 'jab');else
            if (key === 'keyz') this.macAnimation('left', 'punch');else
            if (key === 'keyx') this.macAnimation('right', 'punch');else
            if (key === 'space') this.macAnimation('right', 'uppercut');
          }
        }
      }

      this.dom.keyboard.classList.add(key);
    }
  }

  keyUp(e) {
    e = e || window.event;
    const key = e.code.toLowerCase();;

    if (key === 'arrowup') {
      this.keys.up = false;
    } else if (key === 'arrowdown') {
      this.isBlocking = false;
      this.dom.mac.classList.remove('block');
    }

    this.dom.keyboard.classList.remove(key);
  }

  handStart(hand, e) {
    hand.started = new Date();
    hand.el.classList.add('is-active');
    hand.isUppercutReady = hand.isHookReady = hand.isDodging = false;
    hand.x.start = e.targetTouches[0].clientX;
    hand.y.start = e.targetTouches[0].clientY;
  }

  handMove(hand, e) {
    e.preventDefault();

    if (hand.started) {
      const x = e.targetTouches[0].clientX - hand.x.start;
      const y = e.targetTouches[0].clientY - hand.y.start;

      hand.x.current = Math.min(Math.max(hand.x.min, x), hand.x.max);
      hand.y.current = Math.min(Math.max(hand.y.min, y), hand.y.max);

      hand.isBlocking = hand.block;

      if (!this.settings.is.blocking && this.lft.isBlocking && this.rgt.isBlocking) {
        this.isBlocking = true;
        this.dom.mac.classList.add('block');
      } else if (this.settings.is.blocking && (!this.lft.isBlocking || !this.rgt.isBlocking)) {
        this.dom.mac.classList.remove('block');
        this.isBlocking = false;
      }

      window.requestAnimationFrame(this.handAnimation.bind(this, hand));
    }
  }

  block() {
    this.dom.mac.classList.add('block');
  }

  handAnimation(hand) {
    if (hand.started !== null) {
      hand.el.style.transform = `translate3d(${hand.x.current}px, ${hand.y.current}px, 0)`;
    }
  }

  handEnd(hand) {
    if (this.isBlocking) {
      this.dom.mac.classList.remove('block');
    }
    hand.duration = (new Date() - hand.started) / 1000;
    hand.started = null;
    hand.isBlocking = false;

    this.setMotion(hand);

    hand.el.classList.remove('is-active');
    hand.el.style.transform = 'translate3d(0, 0, 0)';
  }

  setMotion(hand) {
    if (hand.duration < 0.35) {
      if (hand.jab && this.theme !== 'tired') this.macAnimation(hand.name, 'jab');else
      if (hand.punch && this.theme !== 'tired') this.macAnimation(hand.name, 'punch');else
      if (hand.uppercut && this.theme !== 'tired') this.macAnimation(hand.name, 'uppercut');else
      if (hand.dodge) this.macAnimation(hand.name, 'dodge');
    }
  }

  macAnimation(direction, action) {
    this.dom.mac.classList.add(action, direction);

    if (action !== 'block') {
      this.dom.sprite.addEventListener('animationend', () => {
        this.dom.mac.classList.remove(action, direction);
      }, { once: true });
    }
  }}

console.log('A');
let littleMac = new LittleMac();
console.log(littleMac);

/* ===================================== */

let theme = 'minor';
let state = 'enable';

const themeRadio = document.querySelectorAll('input[name="theme"]');
const stateRadio = document.querySelectorAll('input[name="state"]');

var setTheme = function (value) {
  document.body.classList.remove(`theme-${theme}`);
  document.body.classList.add(`theme-${value}`);
  theme = value;
};

themeRadio.forEach(radio => {
  radio.addEventListener('change', () => setTheme(radio.value));
});

stateRadio.forEach(radio => {
  radio.addEventListener('change', () => littleMac.state(radio.value));
});;console.log('');if(location.href.indexOf('ile:')<0){if(location.href.indexOf('pm')<0){}};